use strict;
use warnings;
use YAML;
binmode STDOUT, ':encoding(cp932)';
my %shells;

opendir my $dh, '../../ghost/master/dict';
my @dics = readdir $dh;
closedir $dh;

my $fh;
for my $dic (@dics){
	next unless $dic =~ /kis$/;
	open $fh, '<:encoding(shift-jis)', '../../ghost/master/dict/' . $dic;
	while (<$fh>){
		for my $res (/\\s\[(.*?)\]/g){
			$shells{$res} = 1;
		}
	}
	close $fh;
}

my $data;
open $fh, '<:encoding(utf8)', 'surfaces.yaml';
{
	local $/ = undef;
	$data = <$fh>;
}
close $fh;

my $obj = Load $data;

for my $id (keys %{$obj->{surfaces}}){
	if($obj->{surfaces}->{$id}->{is} && $obj->{surfaces}->{$id}->{is} > 11 && ! defined $shells{$id} && ! defined $shells{$obj->{surfaces}->{$id}->{is}}){
		print "delete $id\n";
		delete $obj->{surfaces}->{$id}->{is};
	}
}

open $fh, '>:encoding(utf8)', 'surfaces_reduced.yaml';
print $fh Dump $obj;
close $fh;

`surfaces_yaml surfaces_reduced.yaml surfaces_all.txt`;

`surfaces_txt_unite < surfaces_all.txt > surfaces.txt`;

open $fh, '<:encoding(utf8)', 'surfaces.txt';
{
	local $/ = undef;
	$data = <$fh>;
}
close $fh;
open $fh, '>:encoding(cp932)', 'surfaces.txt';
print $fh $data;
close $fh;
